/*
   UCD BINARY FORMAT SAMPLE

    UCD oCif[^쐬邽߂̃TvvOłB
    lp`Zitype=3jP쐬܂B

       4(0,1,0)     3(1,1,0)
        +-----------+
        |           |
        |           |
        |           |
        +-----------+
       1(0,0,0)     2(1,0,0)


    Fquad.dat t@C쐬܂B
        ̃t@Cw肷邽߂ .inp t@CiRg[t@Cj
        ʓrKvłiQlFquad.inpjB

*/

// Wlf[^̏o̓^Cv
//   Wl̏o̓^Cvɂ 1  2
//   f[^̏o̓^Cvɂ 1  2  3  4   ܂B
#define I_COORD_FORMAT 1
#define I_NODEDATA_FORMAT 1
#define I_CELLDATA_FORMAT 1

#include <stdio.h>
#include <string.h>

/*
*  main convert program 
*/
int
main(int argc, char *argv[])
{

	/* ۂ̃f[^̃m[hZɉăf[^Ă */
	int id_node[4];
	int id_cell[1];
	int id_mat[1];
	int icell_type[1];
	int icell_connectivity[4];
	float xyz[4][3];
	float node_data[4][3];
	float cell_data[1];
	//
	char keyword[7];
	char title[70];
	float version;
	int stepno;
	float timeval;
	//
	int num_node, num_cell;
	int num_nodedata, num_nodeveclen;
	int num_celldata, num_cellveclen;
	int num_activedata;
	int null_flag;
	float null_value;
	//
	char nodedata_label[16];
	char nodedata_unit[16];
	//
	FILE *fp;
	int ztype, dtype;
	int i, j;

	/* f[^t@C̍쐬 */
	fp = fopen("quad.dat", "wb");
	printf("Open output file: quad.dat\n");

	/* wb_[ */
	strcpy(keyword, "AVS UCD");
	version = 1.0;
	strcpy(title, "ucd binary test data");
	stepno = 1;
	timeval = 1.0;
	fwrite(keyword, 7, 1, fp);
	fwrite(&version, 4, 1, fp);
	fwrite(title, 70, 1, fp);
	fwrite(&stepno, 4, 1, fp);
	fwrite(&timeval, 4, 1, fp);

	/* ߓ_ */
	id_node[0] = 1;
	id_node[1] = 2;
	id_node[2] = 3;
	id_node[3] = 4;
	xyz[0][0] = 0.0;
	xyz[0][1] = 0.0;
	xyz[0][2] = 0.0;
	xyz[1][0] = 1.0;
	xyz[1][1] = 0.0;
	xyz[1][2] = 0.0;
	xyz[2][0] = 1.0;
	xyz[2][1] = 1.0;
	xyz[2][2] = 0.0;
	xyz[3][0] = 0.0;
	xyz[3][1] = 1.0;
	xyz[3][2] = 0.0;

	num_node = 4;
	fwrite(&num_node, 4, 1, fp);
	ztype = (int)I_COORD_FORMAT;
	fwrite(&ztype, 4, 1, fp);
	if (ztype == 1) {
	   for (i = 0; i < 4; i++) {
	      fwrite(&id_node[i], 4, 1, fp);
	      fwrite(&xyz[i], 4, 3, fp);
	   }
	} else if (ztype == 2) {
	   for (i = 0; i < 4; i++) {
	      fwrite(&id_node[i], 4, 1, fp);
	   }
	   for (i = 0; i < 4; i++) {
	      fwrite(&xyz[i][0], 4, 1, fp);
	   }
	   for (i = 0; i < 4; i++) {
	      fwrite(&xyz[i][1], 4, 1, fp);
	   }
	   for (i = 0; i < 4; i++) {
	      fwrite(&xyz[i][2], 4, 1, fp);
	   }
	}
	printf("End node xyz part.\n");

	/* vf */
	id_cell[0] = 1;
	/* FMicroAVS ł̓}eAiޗjID ͕KPɂĉB*/
	id_mat[0] = 1;
	icell_type[0] = (char)3;
	icell_connectivity[0] = 1;
	icell_connectivity[1] = 2;
	icell_connectivity[2] = 3;
	icell_connectivity[3] = 4;

	num_cell = 1;
	fwrite(&num_cell, 4, 1, fp);
	for (i = 0; i < num_cell; i++) {
	   fwrite(&id_cell[i], 4, 1, fp);
	}
	for (i = 0; i < num_cell; i++) {
	   fwrite(&id_mat[i], 4, 1, fp);
	}
	/* FZ^Cv char ^łB */
	for (i = 0; i < num_cell; i++) {
	   fwrite(&icell_type[i], 1, 1, fp);
	}
	for (i = 0; i < num_cell; i++) {
	   fwrite(&icell_connectivity[i], 4, 4, fp);
	}
	
	/* m[hf[^
	   R̃f[^ݒ肵Ă܂B*/
	node_data[0][0] = 1.0;
	node_data[0][1] = 10.0;
	node_data[0][2] = 100.0;
	node_data[1][0] = 2.0;
	node_data[1][1] = 20.0;
	node_data[1][2] = 200.0;
	node_data[2][0] = 3.0;
	node_data[2][1] = 30.0;
	node_data[2][2] = 300.0;
	node_data[3][0] = 4.0;
	node_data[3][1] = 40.0;
	node_data[3][2] = 400.0;

	num_nodedata = 3;
	fwrite(&num_nodedata, 4, 1, fp);
	dtype = (int)I_NODEDATA_FORMAT;
	fwrite(&dtype, 4, 1, fp);
	if (dtype == 1) {
	   for (i = 0; i < num_nodedata; i++) {
	      sprintf(nodedata_label, "xxxx %d", i);
	      strcpy(nodedata_unit, "m/s");
	      /* FMicroAVS ł̓xNgiNUM_NODEVECLENj͕KPɂĉB*/
	      num_nodeveclen = 1;
	      null_flag = 0;
	      null_value = -999.999;
	      fwrite(nodedata_label, 16, 1, fp);
	      fwrite(nodedata_unit, 16, 1, fp);
	      fwrite(&num_nodeveclen, 4, 1, fp);
	      fwrite(&null_flag, 4, 1, fp);
	      fwrite(&null_value, 4, 1, fp);
	   }
	   for (i = 0; i < num_node; i++) {
	      fwrite(&node_data[i], 4, 3, fp);
	   }
	} else if (dtype == 2) {
	   for (i = 0; i < num_nodedata; i++) {
	      sprintf(nodedata_label, "xxxx %d", i);
	      strcpy(nodedata_unit, "m/s");
	      num_nodeveclen = 1;
	      null_flag = 0;
	      null_value = -999.999;
	      fwrite(nodedata_label, 16, 1, fp);
	      fwrite(nodedata_unit, 16, 1, fp);
	      fwrite(&num_nodeveclen, 4, 1, fp);
	      fwrite(&null_flag, 4, 1, fp);
	      fwrite(&null_value, 4, 1, fp);
	   }
	   for (j = 0; j < num_nodedata; j++) {
	      for (i = 0; i < num_node; i++) {
	         fwrite(&node_data[i][j], 4, 1, fp);
	      }
	   }
	} else if (dtype == 3) {
	   for (i = 0; i < num_nodedata; i++) {
	      sprintf(nodedata_label, "xxxx %d", i);
	      strcpy(nodedata_unit, "m/s");
	      num_nodeveclen = 1;
	      fwrite(nodedata_label, 16, 1, fp);
	      fwrite(nodedata_unit, 16, 1, fp);
	      fwrite(&num_nodeveclen, 4, 1, fp);
	   }
	   for (i = 0; i < num_nodedata; i++) {
	      /* FNULL ȊÕf[^ߓ_̃f[^`ł܂B
	            ĩTvł͖gpj*/
	      num_activedata = 4;
	      fwrite(&num_activedata, 4, 1, fp);
	      for (j = 0; j < num_activedata; j++) {
	         fwrite(&id_node[j], 4, 1, fp);
	         fwrite(&node_data[j][i], 4, 1, fp);
	      }
	   }
	} else if (dtype == 4) {
	   for (i = 0; i < num_nodedata; i++) {
	      sprintf(nodedata_label, "xxxx %d", i);
	      strcpy(nodedata_unit, "m/s");
	      num_nodeveclen = 1;
	      fwrite(nodedata_label, 16, 1, fp);
	      fwrite(nodedata_unit, 16, 1, fp);
	      fwrite(&num_nodeveclen, 4, 1, fp);
	   }
	   for (i = 0; i < num_nodedata; i++) {
	      num_activedata = 4;
	      fwrite(&num_activedata, 4, 1, fp);
	      for (j = 0; j < num_activedata; j++) {
	         fwrite(&id_node[j], 4, 1, fp);
	      }
	      for (j = 0; j < num_activedata; j++) {
	         fwrite(&node_data[j][i], 4, 1, fp);
	      }
	   }
	}
	printf("End node data part.\n");

	/* Zf[^
	   ̃Tvł͐ݒ肵Ă܂B
	   Zf[^ꍇm[hf[^ƓtH[}bgŎw肵܂B
	   AZ̐̃f[^`܂B*/
	num_celldata = 0;
	fwrite(&num_celldata, 4, 1, fp);
	printf("End cell data part.\n");

	/* close file */
	fclose(fp);


}

